package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class FusionTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(FusionTri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(int[] tab) {

		trier(tab, 0, tab.length - 1);
	}

	private void trier(int[] tab, int debut, int fin) {

		if (fin <= debut) {
			return;
		}

		// appels recursifs
		final int centre = (debut + fin) / 2;
		trier(tab, debut, centre);
		trier(tab, centre + 1, fin);

		// Fusion
		fusionner(tab, debut, centre, fin);
	}

	private void fusionner(int[] tab, int debut, int centre, int fin) {

		int g = centre;
		int d = centre + 1;

		while (debut <= g && d <= fin) {
			if (tab[debut] < tab[d]) {
				debut++;
			} else {
				// Decallage
				int temp = tab[d];
				for (int i = d - 1; debut <= i; i--) {
					tab[i + 1] = tab[i];
				}
				tab[debut] = temp;
				
				debut++;
				g++;
				d++;
			}
		}
	}

}
