package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class Insertion3Tri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(Insertion3Tri.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.icauda.article.pgm.tri.algo.Tri#trier(int[])
	 */
	@Override
	public int[] trierCopy(final int[] tab) {

		throw new UnsupportedOperationException();
	}

	@Override
	public void trier(final int[] tab) {

		int pos;

		// On peut commencer a 1 directement...
		for (int i = 1; i < tab.length; i++) {

			final int temp = tab[i];

			// Recherche et decalage d'un seul coup
			for (pos = i; 0 < pos && temp < tab[pos - 1]; pos--) {
				tab[pos] = tab[pos - 1];
			}

			// Insertion
			tab[pos] = temp;
		}

	}

	// public void trier_bad(final int[] tab) {
	//
	// long nb = 0;
	//
	// int pos;
	//
	// // On peut commencer a 1 directement...
	// for (int i = 1; i < tab.length; i++) {
	//
	// // Decalage et test d'un seul coup
	// for (pos = i; 0 < pos && tab[i] < tab[pos - 1]; pos--) {
	// tab[pos] = tab[pos - 1];
	// nb++;
	// }
	//
	// // Insertion
	// tab[pos] = tab[i];
	// }
	//
	// logger.debug("nb : {}", nb);
	// }

	public void trier_jdk7(final int[] tab) {

		for (int i = 0; i < tab.length; i++) {
			for (int j = i; j > 0 && tab[j - 1] > tab[j]; j--) {
				permuter(j, j - 1, tab);
			}
		}
	}
}
