package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class InsertionTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(InsertionTri.class);

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.icauda.article.pgm.tri.algo.Tri#trier(int[])
	 */
	@Override
	public int[] trierCopy(final int[] tab) {

		final int[] result = new int[tab.length];

		long nb = 0;
		long nbPermutation = 0;

		for (int i = 0; i < tab.length; i++) {

			// Recherche de la position
			int pos = 0;
			for (pos = 0; pos < i; pos++) {
				nb++;
				if (tab[i] < result[pos]) {
					break;
				}
			}

			// Decalage
			for (int j = i; pos < j; j--) {
				result[j] = result[j - 1];
				nbPermutation++;
			}

			// Insertion a la bonne position
			result[pos] = tab[i];
		}

		logger.debug("nb : {}", nb);
		logger.debug("nbPermutation : {}", nbPermutation);

		return result;
	}

	@Override
	public void trier(final int[] tab) {

		int pos;

		// On peut commencer a 1 directement...
		for (int i = 1; i < tab.length; i++) {

			final int temp = tab[i];

			// recherche position
			for (pos = 0; pos < i; pos++) {
				if (temp < tab[pos]) {
					break;
				}
			}

			// Decaler
			for (int j = i; pos < j; j--) {
				tab[j] = tab[j - 1];
			}

			// Insertion
			tab[pos] = temp;
		}

	}

//	public void trier_bad(final int[] tab) {
//
//		long nb = 0;
//
//		int pos;
//
//		// On peut commencer a 1 directement...
//		for (int i = 1; i < tab.length; i++) {
//
//			// Decalage et test d'un seul coup
//			for (pos = i; 0 < pos && tab[i] < tab[pos - 1]; pos--) {
//				tab[pos] = tab[pos - 1];
//				nb++;
//			}
//
//			// Insertion
//			tab[pos] = tab[i];
//		}
//
//		logger.debug("nb : {}", nb);
//	}

	public void trier_jdk7(final int[] tab) {

		for (int i = 0; i < tab.length; i++) {
			for (int j = i; j > 0 && tab[j - 1] > tab[j]; j--) {
				permuter(j, j - 1, tab);
			}
		}
	}
}
