package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class Rapide2Tri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(Rapide2Tri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(int[] tab) {

		if (tab.length < 2) {
			return;
		}

		int[] tab2 = new int[tab.length];
		trier(tab, tab2, 0, tab.length);
		System.arraycopy(tab2, 0, tab, 0, tab.length);
	}

	private void trier(final int[] tab, final int[] tab2, final int gauche, final int droite) {

		// Choix du pivot a gauche
		final int pivot = tab[gauche];
		int posGauche = gauche;
		int posDroite = droite;

		// Separation en deux sous listes
		for (int index = gauche + 1; index < droite; index++) {
			int elt = tab[index];
			// final int comp = elt-pivot;
			if (elt < pivot) {
				tab2[posGauche++] = elt;
			} else if (elt > pivot) {
				tab2[--posDroite] = elt;
			}
		}

		Arrays.fill(tab2, posGauche, posDroite, pivot);

		if (posGauche > gauche) {
			trier(tab2, tab, gauche, posGauche);
			System.arraycopy(tab, gauche, tab2, gauche, posGauche - gauche);
		}
		if (posDroite < droite) {
			trier(tab2, tab, posDroite, droite);
			System.arraycopy(tab, posDroite, tab2, posDroite, droite - posDroite);
		}

	}

}
