package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class RapideDemiBulleTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(RapideDemiBulleTri.class);
	
	@Override
	public int[] trierCopy(int[] tab) {
		
		final int[] result = Arrays.copyOf(tab, tab.length);
		
		trier(result);
		
		return result;
	}

	@Override
	public void trier(int[] tab) {
		int nb = 0;
		int nbPermutation = 0;
		
		for (int i = 0; i < tab.length; i++) {
			boolean permutation = false;
			for (int j = 1; j < tab.length - i; j++) {
				if (tab[j] < tab[j - 1]) {
					// Permutation
					permuter(j, j - 1, tab);
					permutation = true;
					
					nbPermutation++;
				}
				nb++;
			}
			if (!permutation) {
				break;
			}
		}

		logger.debug("nb : {}", nb);
		logger.debug("nb permutation : {}", nbPermutation);
	}

}
