package com.icauda.article.pgm.tri.algo;

import static com.icauda.article.pgm.tri.util.Elements.permuter;

import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class RapideTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(RapideTri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(final int[] tab) {

		trier(tab, 0, tab.length - 1);

	}

	private void trier(final int[] tab, final int gauche, final int droite) {

		if (droite <= gauche) {
			return;
		}

		// Je commence avec un pivot à gauche
		int positionPivot = gauche;

		// positionPivot = trier(tab, gauche, droite, positionPivot);
		permuter(positionPivot, droite, tab);

		// int j = gauche;
		for (int i = gauche; i < droite; i++) {
			if (tab[i] <= tab[droite]) {
				permuter(i, positionPivot++, tab);
				// positionPivot++;
			}
		}
		permuter(droite, positionPivot, tab);
		// positionPivot = j;

		// tri recursif des sous-listes
		// Bien entendu on ne tri pas le pivot
		trier(tab, gauche, positionPivot - 1);
		trier(tab, positionPivot + 1, droite);
	}

	// private int trier(int[] tab, int gauche, int droite, int positionPivot) {
	// Elements.permuter(positionPivot, droite, tab);
	// int j = gauche;
	// for (int i = gauche; i < droite; i++) {
	// if (tab[i] <= tab[droite]) {
	// Elements.permuter(i, j, tab);
	// j++;
	// }
	// }
	// Elements.permuter(droite, j, tab);
	// return j;
	// }

	// private void trier(final int[] tab, final int gauche, final int droite) {
	//
	// // S'il n'y a qu'un seul element alors il n'y a rien a trier.
	// // Et il est possible que droite soit plus petit que gauche lors des appels
	// // recursifs. Ca m'evite de faire un test a la fin.
	// if (droite <= gauche) {
	// return;
	// }
	//
	// // Je prend le premier element comme pivot.
	// final int pivot = tab[gauche];
	//
	// int g = gauche;
	// int d = droite;
	//
	// while (true) {
	//
	// while (tab[g] < pivot && g < d) {
	// g++;
	// }
	//
	// while (pivot <= tab[d] && g < d) {
	// d--;
	// }
	//
	// if (d == g) {
	// break;
	// }
	//
	// Elements.permuter(g++, d--, tab);
	//
	// }
	//
	// trier(tab, gauche, d - 1);
	// trier(tab, d + 1, droite);
	// }
	//
	// private void trier_bad(final int[] tab, final int gauche, final int droite) {
	//
	// if (droite <= gauche) {
	// return;
	// }
	//
	// // Je choisi le premier element
	// final int pivot = tab[gauche];
	//
	// int g = gauche;
	// int d = droite;
	//
	// while (g < d) {
	//
	// while (g < d && tab[g] < pivot) {
	// g++;
	// }
	//
	// while (g < d && pivot <= tab[d]) {
	// d--;
	// }
	//
	// if (g < d) {
	// Elements.permuter(g, d, tab);
	// d--;
	// g++;
	// }
	// }
	//
	// // Tri sur la partie gauche
	// trier(tab, gauche, g);
	//
	// // Tri sur la partie droite
	// if (droite < droite - 1) {
	// trier(tab, g, droite - 1);
	// } else {
	// trier(tab, g + 1, droite);
	// }
	//
	// }

	private static void print(final int[] tab) {
		final StringBuilder sb = new StringBuilder("tab : ");
		for (final int value : tab) {
			sb.append(value).append("-");
		}
		System.out.println(sb.toString());
	}

}
