package com.icauda.article.pgm.tri.algo;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.icauda.article.pgm.tri.util.Elements;

public class RapideViaListeTri implements Tri {

	private static final Logger logger = LoggerFactory.getLogger(RapideViaListeTri.class);

	@Override
	public int[] trierCopy(int[] tab) {

		final int[] result = Arrays.copyOf(tab, tab.length);

		trier(result);

		return result;
	}

	@Override
	public void trier(final int[] tab) {

		final List<Integer> liste = tabToList(tab);

		final List<Integer> result = trier(liste);

		ecraser(result, tab);

	}

	private List<Integer> trier(final List<Integer> liste) {

		if (liste == null || liste.isEmpty()) {
			return new ArrayList<>();
		}

		// Choix du pivot a gauche
		final int pivot = liste.get(0);
		// pour ne pas traiter le pivot dans la boucle
		liste.remove(0);

		final List<Integer> listeGauche = new ArrayList<>();
		final List<Integer> listeDroite = new ArrayList<>();

		// Separation en deux sous listes
		for (final int elt : liste) {
			if (elt < pivot) {
				listeGauche.add(elt);
			} else {
				listeDroite.add(elt);
			}
		}

		final List<Integer> result = new ArrayList<>();

		result.addAll(trier(listeGauche));
		result.add(pivot);
		result.addAll(trier(listeDroite));

		return result;
	}

	private List<Integer> tabToList(final int[] tab) {
		final List<Integer> liste = new ArrayList<>(tab.length);

		for (final int elt : tab) {
			liste.add(elt);
		}

		return liste;
	}

	private void ecraser(final List<Integer> from, final int[] to) {
		int i = 0;
		for (final int elt : from) {
			to[i++] = elt;
		}
	}

}
